#include <sourcemod>
#include <sdktools>
#undef REQUIRE_EXTENSIONS
#undef REQUIRE_PLUGIN
#include <mapchooser>
#pragma semicolon 1
#define VERSION "1.0"
#define WHITE 0x01
#define GREEN 0x04
#define LIMEGREEN 0x06
#define YELLOW 0x09
#define LIGHTRED 0x0F

//decl.
new Handle:g_hDb = INVALID_HANDLE;
new Handle:g_hCalcFactor = INVALID_HANDLE;
new Handle:g_hMaxExtensionTime = INVALID_HANDLE;
new Handle:g_hRtv = INVALID_HANDLE;
new Handle:g_hSound = INVALID_HANDLE;
new Handle:g_hVip = INVALID_HANDLE;
new Handle:g_hWeclomeMsg = INVALID_HANDLE;
new Handle:Timer[MAXPLAYERS+1];
new g_PlayTime[MAXPLAYERS+1];
new g_MaxExtensionTime;
new g_CalcFactor;
new g_ExtensionTimeCounter;
new bool:g_bRtv;
new bool:g_bWeclomeMsg;
new bool:g_bVip;
new bool:g_bRtvPluginEnabled;
new bool:g_bSound;
new String:g_szMapName[64];
new String:g_szSteamID[MAXPLAYERS+1][32];  
new const String:FULL_SOUND_PATH[] = "sound/smsounds/endofvote.mp3";
new const String:RELATIVE_SOUND_PATH[] = "*smsounds/endofvote.mp3";

public Plugin:myinfo =
{
	name = "Map extension by players",
	author = "1NutWunDeR",
	description = "This plugin allows players to increase the value of mp_timelimit",
	version = VERSION
}

public db_setupDatabase()
{
	decl String:szError[255];
	g_hDb = SQL_Connect("player_extension", false, szError, 255);
        
	if(g_hDb == INVALID_HANDLE)
	{
		SetFailState("Unable to connect to database (%s)",szError);
		return;
	}
        	
	//create table
	SQL_LockDatabase(g_hDb);     
	SQL_FastQuery(g_hDb, "CREATE TABLE IF NOT EXISTS players (steamid VARCHAR(32), time INT(12) DEFAULT '0', PRIMARY KEY(steamid));");
	SQL_UnlockDatabase(g_hDb);
}

public OnPluginStart()
{
	db_setupDatabase();
	
	CreateConVar("sm_mebp_version", VERSION, "mebp version", FCVAR_DONTRECORD|FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);

	g_hCalcFactor   = CreateConVar("sm_mebp_minutes", "10.0", "Necessary play time to receive 1 minute for a map extension", FCVAR_PLUGIN|FCVAR_NOTIFY, true, 5.0, true, 9999.0);
	g_CalcFactor    = GetConVarInt(g_hCalcFactor);
	HookConVarChange(g_hCalcFactor, OnSettingChanged);	
	
	g_hMaxExtensionTime   = CreateConVar("sm_mebp_max_minutes", "60.0", "Maximum time extension on a map", FCVAR_PLUGIN|FCVAR_NOTIFY, true, 1.0, true, 99999.0);
	g_MaxExtensionTime    = GetConVarInt(g_hMaxExtensionTime);
	HookConVarChange(g_hMaxExtensionTime, OnSettingChanged);	

	g_hRtv = CreateConVar("sm_mebp_disable_rtv", "1", "on/off - disables rock the vote until the player map extension is expired", FCVAR_PLUGIN|FCVAR_NOTIFY, true, 0.0, true, 1.0);
	g_bRtv    = GetConVarBool(g_hRtv);
	HookConVarChange(g_hRtv, OnSettingChanged);

	g_hSound = CreateConVar("sm_mebp_extension_sound", "1", "on/off - extension sound", FCVAR_PLUGIN|FCVAR_NOTIFY, true, 0.0, true, 1.0);
	g_bSound    = GetConVarBool(g_hSound);
	HookConVarChange(g_hSound, OnSettingChanged);

	g_hVip = CreateConVar("sm_mebp_vip_only", "0", "on/off - only vips and admins are allowed to use !ext", FCVAR_PLUGIN|FCVAR_NOTIFY, true, 0.0, true, 1.0);
	g_bVip    = GetConVarBool(g_hVip);
	HookConVarChange(g_hVip, OnSettingChanged);

	g_hWeclomeMsg = CreateConVar("sm_mebp_welcome_msg", "1", "on/off - welcome chat message", FCVAR_PLUGIN|FCVAR_NOTIFY, true, 0.0, true, 1.0);
	g_bWeclomeMsg    = GetConVarBool(g_hWeclomeMsg);
	HookConVarChange(g_hWeclomeMsg, OnSettingChanged);
	
	RegConsoleCmd("sm_ext", Client_Extend, "opens the extension menu");	
	AutoExecConfig(true, "map_extension_by_players");
}

public OnSettingChanged(Handle:convar, const String:oldValue[], const String:newValue[])
{	
	if(convar == g_hSound)
	{
		if(newValue[0] == '1')		
			g_bSound = true;
		else
			g_bSound = false;
	}
	if(convar == g_hRtv)
	{
		if(newValue[0] == '1')		
			g_bRtv = true;
		else
			g_bRtv = false;
	}
	if(convar == g_hVip)
	{
		if(newValue[0] == '1')		
			g_bVip = true;
		else
			g_bVip = false;
	}
	if(convar == g_hWeclomeMsg)
	{
		if(newValue[0] == '1')		
			g_bWeclomeMsg = true;
		else
			g_bWeclomeMsg = false;
	}
	if(convar == g_hCalcFactor)
		g_CalcFactor = StringToInt(newValue[0]);	
	if(convar == g_hMaxExtensionTime)
		g_MaxExtensionTime = StringToInt(newValue[0]);		 
}

public OnMapStart()
{
	//check rtv plugins
	g_bRtvPluginEnabled = false;
	new Handle:tmp = FindPluginByFile("rockthevote.smx");
	if (tmp != INVALID_HANDLE && GetPluginStatus(tmp) == Plugin_Running)
		g_bRtvPluginEnabled = true;
	tmp =  FindPluginByFile("rockthevote_extended.smx");
	if (tmp != INVALID_HANDLE && GetPluginStatus(tmp) == Plugin_Running) 
		g_bRtvPluginEnabled = true;
	if (tmp != INVALID_HANDLE)
		CloseHandle(tmp);
		
	//get mapname
	GetCurrentMap(g_szMapName, 64);
			
	//workshop fix
	new String:mapPieces[6][128];
	new lastPiece = ExplodeString(g_szMapName, "/", mapPieces, sizeof(mapPieces), sizeof(mapPieces[])); 
	Format(g_szMapName, sizeof(g_szMapName), "%s", mapPieces[lastPiece-1]); 
	
	g_ExtensionTimeCounter = 0;
	AddFileToDownloadsTable(FULL_SOUND_PATH);
	FakePrecacheSound(RELATIVE_SOUND_PATH);	
}

public OnClientPutInServer (client)
{
	if ((client == 0) || !IsClientConnected (client))
		return;
	if (g_bWeclomeMsg)
		CreateTimer (35.0, WelcomeMsg, client);
}

public Action:WelcomeMsg (Handle:timer, any:client)
{
    if (IsValidClient(client))
        PrintToChat (client, "You have the opportunity to extend the current map by typing %c!ext%c in chat.", YELLOW,WHITE);
    return Plugin_Stop;
}

public OnClientPostAdminCheck(client)
{
	if (IsFakeClient(client))
		return;
	GetClientAuthString(client, g_szSteamID[client], 32);
	db_viewPlayTime(client);	
}

public db_viewPlayTime(client)
{
	decl String:szQuery[128];      
	Format(szQuery, 128, "SELECT time from players where steamid = '%s';", g_szSteamID[client]);     
	SQL_TQuery(g_hDb, db_viewPlayTimeCallBack, szQuery, client,DBPrio_Low);
}

public db_viewPlayTimeCallBack(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	new client = data;
	decl String:szQuery[128];  
	g_PlayTime[client] = 0;	
	if(SQL_HasResultSet(hndl) && SQL_FetchRow(hndl))
		g_PlayTime[client] = SQL_FetchInt(hndl, 0);	
	else
	{
		Format(szQuery, 128, "INSERT INTO players (steamid, time) VALUES('%s',0);", g_szSteamID[client]);   
		SQL_TQuery(g_hDb, db_CheckCallBack, szQuery, DBPrio_Low);
	}
	if (OnlyVips(client))
		return;
	Timer[client] = CreateTimer(60.0, TimeCount, client, TIMER_FLAG_NO_MAPCHANGE|TIMER_REPEAT);
}

public Action:TimeCount(Handle:timer, any:client)
{
	if (!IsValidClient(client))
		return Plugin_Continue;
	g_PlayTime[client]++;
	return Plugin_Continue;
}

public db_CheckCallBack(Handle:owner, Handle:hndl, const String:error[], any:data)
{
}

public OnClientDisconnect(client)
{
	if (IsFakeClient(client))
		return;
	if (Timer[client] != INVALID_HANDLE)
	{
		KillTimer(Timer[client]);
		Timer[client] = INVALID_HANDLE;
	}
	if (OnlyVips(client))
		return;
	decl String:szQuery[128];      
	Format(szQuery, 128, "UPDATE players SET time = '%i' where steamid='%s'",g_PlayTime[client], g_szSteamID[client]);     
	SQL_TQuery(g_hDb, db_CheckCallBack, szQuery, client,DBPrio_Low);
}


public Action:Client_Extend(client,args)
{
	if (IsValidClient(client))
	{
		if (OnlyVips(client))
		{
			PrintToChat(client, "[SM] You do not have access to this command. (VIP/ADMIN ONLY)");
			return Plugin_Handled;
		}
		AddTimeMenu(client);
	}
	return Plugin_Handled;
}

public AddTimeMenu(client) 
{
	new Handle:menu = CreateMenu(AddTimeMenuHandler);
	decl String:szTitle[256];  
	new mins = RoundToZero(float(g_PlayTime[client]) / float(g_CalcFactor));
	Format(szTitle, 256, "Choose the amount of minutes you would like to extend\navailable minutes: %i (You will receive 1min through %imins play time)\n \n", mins,g_CalcFactor);  
	//5mins
	if (mins >= 5)
		AddMenuItem(menu, "5", "5 minutes");
	else
		AddMenuItem(menu, "5", "5 minutes",ITEMDRAW_DISABLED);
	//10mins	
	if (mins >= 10)	
		AddMenuItem(menu, "10", "10 minutes");
	else
		AddMenuItem(menu, "10", "10 minutes",ITEMDRAW_DISABLED);
	//15mins
	if (mins >= 15)
		AddMenuItem(menu, "15", "15 minutes");
	else
		AddMenuItem(menu, "15", "15 minutes",ITEMDRAW_DISABLED);
	//20mins	
	if (mins >= 20)
		AddMenuItem(menu, "20", "20 minutes");
	else
		AddMenuItem(menu, "20", "20 minutes",ITEMDRAW_DISABLED);
	
	SetMenuTitle(menu, szTitle);
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);		
}

public AddTimeMenuHandler(Handle:menu, MenuAction:action, client, itemNumber) 
{
	if (action == MenuAction_Select) 
	{
		switch(itemNumber)
		{
			case 0: AddTime(client,5);
			case 1: AddTime(client,10);
			case 2: AddTime(client,15);
			case 3: AddTime(client,20); 
		}															
	}
}

public AddTime(client, extratime)
{
	if (IsValidClient(client))
	{
		if (g_MaxExtensionTime > g_ExtensionTimeCounter)
		{
			decl String:szClientName[32];
			GetClientName(client, szClientName, 32);
			
			//add time
			g_PlayTime[client]-= (g_CalcFactor * extratime);
			new Handle:hTimelimit = FindConVar("mp_timelimit");
			new Float:flTimelimit = GetConVarFloat(hTimelimit);
			if (flTimelimit != 0.0)
			{
				new flags = GetConVarFlags(hTimelimit);
				flags &= ~FCVAR_NOTIFY;
				SetConVarFlags(hTimelimit, flags);
				SetConVarFloat(hTimelimit, GetConVarFloat(hTimelimit) + float(extratime));
				g_ExtensionTimeCounter += extratime;
			}
			else
			{
				PrintToChat(client, " %cYou can't add minutes because the current map doesn't have a time limit.",LIGHTRED);
				CloseHandle(hTimelimit);
				return;
			}
			CloseHandle(hTimelimit);
			
			
			//new timeleft
			new timeleft;
			GetMapTimeLeft(timeleft);
			new mins;	
			decl String:finalOutput[16];
			mins = timeleft / 60;
			Format(finalOutput, 16, "%d", mins);
			
			//restrict rtv
			if (g_bRtv && g_bRtvPluginEnabled)
				RestrictRtv(extratime);	
			
			//chat msg
			PrintToChatAll(" %c%s%c has added %c%i%c minutes to the current time limit. %smins remaining on %s!", GREEN,szClientName,LIMEGREEN,GREEN,extratime,LIMEGREEN,finalOutput,g_szMapName);
		
			//sound
			if (g_bSound)
			{
				for(new i = 1; i <= GetMaxClients(); i++) 
				{ 
					if(IsValidClient(i)) 
					{ 
						decl String:buffer[64];
						Format(buffer, sizeof(buffer), "play %s", RELATIVE_SOUND_PATH); 
						ClientCommand(i, buffer); 
					}
				}
			}
		}
		else
			PrintToChat(client, " %cMaximum extension time of %imins already reached.",LIGHTRED,g_MaxExtensionTime);
	}
}

public bool:IsValidClient(client)
{
    if(client >= 1 && client <= MaxClients && IsValidEntity(client) && IsClientConnected(client) && IsClientInGame(client))
        return true;  
    return false;
} 

public bool:OnlyVips(client)
{
	if (g_bVip && !(GetUserFlagBits(client) & ADMFLAG_RESERVATION) && !(GetUserFlagBits(client) & ADMFLAG_ROOT) && !(GetUserFlagBits(client) & ADMFLAG_GENERIC))
		return true;
	return false;
} 

public FakePrecacheSound( const String:szPath[] )
	AddToStringTable( FindStringTable( "soundprecache" ), szPath );